package converters;

import java.io.*;
import java.text.*;
import java.util.*;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

public class ConvertTag extends TagSupport {
	private static final double exchangeRate = 0.613;
    private Currency pounds = Currency.getInstance(Locale.UK);
    private NumberFormat nf = NumberFormat.getInstance();
	private String dollarValue;

	public String getDollarValue() { return dollarValue; }

	public void setDollarValue(String dollarValue)
		{ this.dollarValue = dollarValue; }

	public int doStartTag() throws JspException {
		try {
			double value = nf.parse(dollarValue).doubleValue();
		    nf.setMaximumFractionDigits(pounds.getDefaultFractionDigits());
		    nf.setMinimumFractionDigits(pounds.getDefaultFractionDigits());
		    pageContext.getOut().print(nf.format(value*exchangeRate));
		} catch (ParseException ex) {
		    throw new JspTagException(
				"ConvertTag: illegal dollar value: "+dollarValue);
		} catch (NullPointerException ex) {
		    throw new JspTagException("ConvertTag: no dollar value specified");
		} catch (IOException ex) {
		    throw new JspTagException("ConvertTag: "+ex);
		}
		return SKIP_BODY;
	}
}
