package converters;

import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;

public class IterateOverTag extends TagSupport {
	private double from;
	public Double getFrom() { return new Double(from); }
	public void setFrom(Double from) { this.from = from.doubleValue(); }

	private double to;
	public Double getTo() { return new Double(to); }
	public void setTo(Double to) { this.to = to.doubleValue(); }

	private double step = 1.0;
	public Double getStep() { return new Double(step); }
	public void setStep(Double step) { this.step = step.doubleValue(); }

	private double current;
	public double getCurrent() { return current; }

	public int doStartTag() throws JspException {
		current = from;
		if (current > to)
			return SKIP_BODY;
		return EVAL_BODY_INCLUDE;
	}

	public int doAfterBody() throws JspException {
		current += step;
		if (current > to) {
			return SKIP_BODY;
		}
		return EVAL_BODY_AGAIN;
	}
}
