package filters;

import java.io.*;
import java.sql.*;
import java.text.*;
import javax.naming.*;
import javax.servlet.*;
import javax.servlet.http.*;
import converters.*;

public class ActionFilter implements Filter {

    public void init(FilterConfig filterConfig) throws ServletException {}
    public void destroy() {}

    public void doFilter(ServletRequest request, ServletResponse response,
     	    FilterChain chain) throws IOException, ServletException {

	if (request instanceof HttpServletRequest) {
	    HttpServletRequest httpReq = ((HttpServletRequest) request);

	    HttpSession session = httpReq.getSession();
	    String amount = httpReq.getParameter("amount");
	    try {
	        ConverterBean convert =
		    (ConverterBean)session.getAttribute("convert");
	        if (convert == null)
		    session.setAttribute("convert",convert=new ConverterBean());
	        String from = httpReq.getParameter("countryFrom");
	        String to = httpReq.getParameter("countryTo");
		if (from!=null && from.length()>0 && to!=null && to.length()>0)
			convert.setCountries(from,to);
		if (amount!=null && amount.length()>0)
			convert.setAmount(amount);
	    }
	    catch (NamingException ex) {
		httpReq.setAttribute("exception",ex);
		httpReq.getRequestDispatcher("databaseError.jsp").
		    forward(request,response);
	    }
	    catch (SQLException ex) {
		httpReq.setAttribute("exception",ex);
		httpReq.getRequestDispatcher("databaseError.jsp").
		    forward(request,response);
	    }
	    catch (ParseException ex) {
		httpReq.setAttribute("message",
		    "<FONT color='red'>Invalid value for amount: " +
			amount + "</FONT>");
	    }
	    catch (IllegalArgumentException ex) {
		httpReq.setAttribute("message",
		  "<FONT COLOR='red'>"+ex.getMessage()+"</FONT>");
	    }
	    chain.doFilter(httpReq, response);
	}
	else
	    chain.doFilter(request, response);
    }
}