package filters;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class PageHitCountFilter implements Filter {

    private FilterConfig filterConfig = null;

    public void init(FilterConfig filterConfig) throws ServletException {
	this.filterConfig = filterConfig;
    }

    public void destroy() {
        this.filterConfig = null;
    }

    public void doFilter(ServletRequest request, ServletResponse response,
	    FilterChain chain) throws IOException, ServletException {

	if (filterConfig == null)
            throw new ServletException();

	ServletContext context = filterConfig.getServletContext();
	if (request instanceof HttpServletRequest) {
	    HttpServletRequest httpReq = ((HttpServletRequest) request);

	    HashMap hitCountMap = (HashMap) context.getAttribute("hitCounts");
	    if (hitCountMap == null) {
		context.setAttribute("hitCounts", hitCountMap = new HashMap());
	    }
	    String servletName = httpReq.getServletPath();
	    Integer hits = (Integer) hitCountMap.get(servletName);
	    if (hits == null)
		hits = new Integer(1);
	    else
		hits = new Integer (hits.intValue() + 1);
	    hitCountMap.put(servletName, hits);
	    context.setAttribute("hitCounts", hitCountMap);
	}
	chain.doFilter(request, response);
    }
}
