import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;
import javax.naming.*;
import javax.sql.*;

public class ListTables extends HttpServlet {

    private void printRows (PrintWriter out, ResultSet rows)
	    throws SQLException{
        out.println ("<TABLE width='35%' border='0'>");
 	while (rows.next()) {
	    out.println ("<TR>");
	    out.println(" <TD>" + rows.getString(1)+ "</TD><TD>" + rows.getString(2) + "</TD>");
            out.println ("</TR>");
	}
	out.println ("</TABLE>");
    }

    public void doGet(HttpServletRequest req, HttpServletResponse res)
    			 throws ServletException, IOException {
	res.setContentType("text/html");
	PrintWriter out = res.getWriter();
        out.println ("<HTML>");
        out.println ("<HEAD><TITLE>Currency Conversion</TITLE></HEAD>");
        out.println ("<BODY>");
	out.println ("<H1><A href='homepage'><img src='images/tomcat.gif' border='0'></A> List Tables</H1>");
	try {
	    Context init = new InitialContext();
	    Context ctx = (Context) init.lookup("java:comp/env");
	    DataSource ds = (DataSource) ctx.lookup("jdbc/security");
	    Connection con = ds.getConnection();
	    PreparedStatement select = con.prepareStatement(
	        "SELECT * FROM userroles WHERE username like ?");
	    out.println("<H1>User Table</H1>");

	    if (req.isUserInRole("admin"))
		select.setString(1,"%");
	    else
		select.setString(1,req.getUserPrincipal().getName());
	    ResultSet rows = select.executeQuery();
	    if (rows != null)
	        printRows(out, rows);
            out.println ("</BODY>");
            out.println ("</HTML>");
	}

        catch (SQLException ex) {
	    System.out.println("SQL Exception thrown: "+ex);
	    ex.printStackTrace();
    	}
	catch (NamingException ex) {
	    System.out.println("Naming Exception thrown: "+ex);
	    ex.printStackTrace();
    	}
    }
}