import java.io.*;
import java.sql.*;
import java.text.*;
import java.util.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.naming.*;
import javax.servlet.*;
import javax.servlet.http.*;
import converters.*;

public class ConvertMail extends HttpServlet
{
	public void doGet(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException {

		String forward = "converted.jsp";
		HttpSession session = request.getSession();
		String amount = request.getParameter("amount");
		String email = request.getParameter("email");
		try {
			ConverterBean convert =
			    (ConverterBean)session.getAttribute("convert");
			if (convert == null)
				session.setAttribute("convert",convert=new ConverterBean());
			if (amount!=null && amount.length()>0) {
			    if (email==null || email.length()==0)
				    throw new IllegalArgumentException("Email address not defined");
				convert.setAmount(amount);
				String result = convert.getAmount() + " = " +
					convert.getConvertedAmount();

				Context init = new InitialContext();
				Context ctx = (Context) init.lookup("java:comp/env");
				Session mailer = (Session) ctx.lookup("mail/session");

				Message message = new MimeMessage(mailer);
				message.setFrom(new InternetAddress("currency@converter"));
				InternetAddress to[] = new InternetAddress[1];
				to[0] = new InternetAddress(email);
				message.setRecipients(Message.RecipientType.TO, to);
				message.setSubject("Currency conversion: "+convert.getAmount());
				message.setContent(result,"text/plain");
				Transport.send(message);
				request.setAttribute("message",
				  "<H2>Converted value emailed to "+email+"</H2>");
			}
		}
		catch (NamingException ex) {
			request.setAttribute("exception",ex);
			forward = "databaseError.jsp";
		}
		catch (SQLException ex) {
			request.setAttribute("exception",ex);
			forward = "databaseError.jsp";
		}
		catch (AddressException ex) {
			request.setAttribute("exception",ex);
			forward = "databaseError.jsp";
		}
		catch (MessagingException ex) {
			request.setAttribute("exception",ex);
			forward = "databaseError.jsp";
		}
		catch (java.text.ParseException ex) {
			request.setAttribute("message",
			  "<FONT color='red'>Invalid value for amount: "+amount+"</FONT>");
		}
		catch (IllegalArgumentException ex) {
			request.setAttribute("message",
			  "<FONT COLOR='red'>"+ex.getMessage()+"</FONT>");
		}

		request.getRequestDispatcher(forward).forward(request,response);
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
		throws ServletException, IOException {
		doGet(request,response);
	}
}